SystemOrganization addCategory: #'Magma seaside'!

!MaObjectRepository methodsFor: '*magma seaside' stamp: 'kph 9/20/2006 23:38'!
graphBufferAt: oidInteger using: aMaReadStrategy
	"Answers a MaSerializedGraphBuffer."

	| answer rootBuffer |
	answer _ MaSerializedGraphBuffer new: 400.
	rootBuffer _ 
		filer
			appendObject: oidInteger
			into: answer.

	rootBuffer
		appendGraphUsing: (aMaReadStrategy signalBeginningToRead: oidInteger)
		into: answer
		currentDepth: 1
		minDepth: aMaReadStrategy minimumDepth
		with: Set new
		filer: filer.
	^ answer! !

!WAConfigurationEditor methodsFor: '*magma seaside' stamp: 'kph 5/24/2007 11:54'!
renderMagmaLocationAttribute: anAttribute on: html

	| location |
	location := configuration valueForAttribute: anAttribute.

	html div id: 'location'; with: [
		html table: [
			(location respondsTo: #comment) ifTrue: [ html small: location comment ].
			location isLocal
				ifTrue: [
					html tableRow: [  
						html tableData id: 'label'; with: 'path:'.
						html tableData: [ html textInput on: #path of: location ]
					]
				] ifFalse: [
					html tableRow: [  
						html tableData id: 'label'; with: 'host'.
						html tableData: [ html textInput on: #host of: location ]
					].
					html tableRow: [  
						html tableData id: 'label'; with: 'port'.
						html tableData: [ html textInput value: location port;
								callback: [:v | location port: v asNumber] ]
					].
				]
		]
	].
! !

!WAConfigurationEditor methodsFor: '*magma seaside' stamp: 'kph 6/15/2006 20:33'!
visitMagmaLocationAttribute: anAttribute with: html

	| location |
	location := configuration valueForAttribute: anAttribute. 

	html select 
		list: anAttribute options;
		selected: location class;
		beSubmitOnChange;
		labels: [ :ea | ea name ];
		callback: [ :item | 	(configuration valueAt: #location) class == item
			ifFalse: [ configuration takeValue: item default forAttribute: anAttribute. ]
 		];
		yourself.

	self renderMagmaLocationAttribute: anAttribute on: html.! !

!MaObjectBuffer methodsFor: '*magma seaside' stamp: 'kph 9/20/2006 13:39'!
appendGraphUsing: aMaReadStrategy into: aMaSerializedGraphBuffer currentDepth: currentDepth minDepth: minDepth with: alreadyAppendedSet filer: aMaObjectFiler

	1
		to: self objectInstSize
		do:
			[ :varIndex | | oid |
			(MaOidCalculator isOidForOptimizedObject: (oid _ self maInstVarAt: varIndex))
				ifFalse:
					[ | newMinDepth | 

				(newMinDepth := aMaReadStrategy 
						testRead: oid
						wantedAt: currentDepth
						to: minDepth
						forAttribute: varIndex
						ofClassWithId: self classId
						version: self classVersion) ~= false ifTrue: [
						
							self
								appendGraphNode: oid
								into: aMaSerializedGraphBuffer
								using: aMaReadStrategy
								currentDepth: currentDepth
								minDepth: newMinDepth
								with: alreadyAppendedSet
								filer: aMaObjectFiler 
							].
					  ]
		]
! !

WASystemConfiguration subclass: #WAMagmaConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'mmb 12/5/2005 09:17'!
ancestors

	^ Array with: (WARenderLoopConfiguration new)! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 14:08'!
attributes
    "Return the attributes specific to this configuration"

	^ Array with: (WAMagmaLocationAttribute key: #location group: #magma)
			 with: ((WAListAttribute key: #readStrategy group: #magma)
						options: self readStrategyClasses; yourself )
			with: (WABooleanAttribute key: #signalProxyMaterializations group: #magma)
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 11:44'!
location

	^ MagmaLocalLocation default
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 14:12'!
readStrategyClasses 

^ WAMagmaReadStrategyDefault withAllSubclasses 
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 14:10'!
readStrategy 

^ WAMagmaReadStrategyDefault 
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 11:35'!
repositoryPath

	^ 'store'
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 11:24'!
sessionClass

	^ WAMagmaSession! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 14:12'!
signalProxyMaterializations 

	^ false! !

WAComponent subclass: #WAMagmaLog
	instanceVariableNames: 'entries printBlocks maxEntries serializer classIdManager firstTime readStrategy showReadStrategy readCount'
	classVariableNames: 'Log'
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaLog class methodsFor: 'nil' stamp: 'kph 9/20/2006 16:08'!
log

Log ifNil: [ Log := self new ].
^Log! !

!WAMagmaLog class methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 05:16'!
reset

Log := nil.! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 00:41'!
classIdManager

^classIdManager! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 01:53'!
clear

entries := OrderedCollection new: maxEntries.
readCount := 0.
! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 05:57'!
entries

^entries! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/24/2006 03:50'!
entry: type context: aContext 

entries size < maxEntries ifTrue: [ 

| context |

context := entries add: aContext copy.
context setSender: nil 
		receiver: (type, ':i:on:') asSymbol
		method: context method 
		arguments: #()

]
	 ! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 22:18'!
forApplication: anEntryPoint

	| session |

	  
	session := ((anEntryPoint preferenceAt: #sessionClass) application: anEntryPoint) obtainMagmaSession.

	readStrategy := session readStrategy.
	serializer := session serializer.
	classIdManager := serializer classIdManager.

 ! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 23:49'!
formatterClass

^WAMagmaLogEntryFormatter! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 23:17'!
initialize

maxEntries := 200.
self clear.
readStrategy := nil.! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 22:43'!
keyString

^ 'n: [ms] (current/min/newMin) class-attribute = value'! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 05:18'!
maxEntries

^maxEntries! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 05:18'!
maxEntries: n

maxEntries := n! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 13:45'!
printIndex: i entry: context on: html
"
context expected for
entryForReading: oid at: currentDepth to: minDepth attribute: varIndex ofClassId: classId version: classVersion 
"

| theClass theAttributeName theValue out |

firstTime ifNil: [ firstTime := context tempAt: 8 ].

context isString ifTrue: [  html text: (i asString, ': ', context). html break. ^self ].

classIdManager ifNil: [ ^html strong: '<<no class id manager available>>' ].

theClass := classIdManager classForId: (context tempAt: 5) ifAbsent: [ ^self error: 'could not find class id' ].
theAttributeName := theClass allInstVarNames at: (context tempAt: 4) ifAbsent: [  (context tempAt: 4) asString ].
theValue := serializer objectWithOid: (context tempAt: 1).

out :=  (String streamContents: [ :stream | 

stream 	nextPutAll: i asString;
		nextPutAll: ': [';
		nextPutAll: ((context tempAt: 8) - firstTime) asString;
		nextPutAll: '] (';
		nextPutAll: (context tempAt: 2) asString;
		nextPut: $/;
		nextPutAll: (context tempAt: 3) asString.

(context tempAt: 7) ~= false ifTrue: [
stream		nextPut: $/;
		nextPutAll: (context tempAt: 7) asString ].
stream		nextPutAll: ') ';
		nextPutAll: theClass name;
		nextPut: $-;
		nextPutAll: theAttributeName;
		nextPutAll: ' = ';
		nextPutAll: (theValue printStringLimitedTo: 40);
		yourself.	
]).

(context tempAt: 7) = false ifTrue: [ html text: out ] ifFalse: [ html strong: out ].
html break.

! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 13:43'!
readBegin: context i: entryIndex on: html
 
| theValue |

firstTime ifNil: [ firstTime := context at: 2 ].

readCount := readCount + 1.

html horizontalRule.
theValue := serializer objectWithOid: (context at: 1 ).

html strong: entryIndex asString, (' [', ((context at: 2) - firstTime) asString, '] Read(', readCount asString, ') '); text: (theValue printStringLimitedTo: 70) ; break.

(readCount = 1) ifTrue: [ firstTime := nil ].

 ! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 22:37'!
refresh! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 13:43'!
renderContentOn: html

|   |

html form: [
	html strong: 'Magma Log '.
	html text: 'entries: '.
	html textInput on: #maxEntries of: self.
	html submitButton on: #clear of: self.
	html submitButton on: #refresh of: self.
	html text: ' show read strategy'.
	html checkbox  on: #showReadStrategy of: self.
	html horizontalRule.
	self showReadStrategy ifTrue: [ self renderReadStrategyOn: html. 
					html horizontalRule.
 				].
].

html text: self keyString; horizontalRule.

firstTime := nil.
 
self entries withIndexDo:  [ :context :entryIndex |  self perform: context receiver with: context with: entryIndex with: html ].

html break.

! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 15:09'!
rendererClass

^WARenderCanvas
! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 13:43'!
renderReadStrategyOn: html

readStrategy ifNil: [ ^self ].

html strong: 'Read strategy: '.
readStrategy renderOn: html! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 13:43'!
seaside: context i: entryIndex on: html

firstTime ifNil: [ firstTime := context at: 2 ].

html strong: (entryIndex asString, ': [', ((context at: 2) - firstTime) asString, '] ', (context at: 1)).

html break.! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 00:41'!
serializer

^serializer! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2006 03:09'!
showReadStrategy

^showReadStrategy ifNil: [ true ]! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 22:22'!
showReadStrategy: bool

showReadStrategy := bool! !

!WAMagmaLog methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 13:45'!
testRead: context i: entryIndex on: html

"
context expected for
entryForReading: oid at: currentDepth to: minDepth attribute: varIndex ofClassId: classId version: classVersion 
"
 

| theClass theAttributeName theValue out |

firstTime ifNil: [ firstTime := context tempAt: 8 ].

classIdManager ifNil: [ ^html strong: '<<no class id manager available>>' ].

theClass := classIdManager classForId: (context tempAt: 5) ifAbsent: [ ^self error: 'could not find class id' ].
theAttributeName := theClass allInstVarNames at: (context tempAt: 4) ifAbsent: [  (context tempAt: 4) asString ].
theValue := serializer objectWithOid: (context tempAt: 1).

out :=  (String streamContents: [ :stream | 

stream 	nextPutAll: entryIndex asString;
		nextPutAll: ': [';
		nextPutAll: ((context tempAt: 8) - firstTime) asString;
		nextPutAll: '] (';
		nextPutAll: (context tempAt: 2) asString;
		nextPut: $/;
		nextPutAll: (context tempAt: 3) asString.

(context tempAt: 7) ~= false ifTrue: [
stream		nextPut: $/;
		nextPutAll: (context tempAt: 7) asString ].
stream		nextPutAll: ') ';
		nextPutAll: theClass name;
		nextPut: $-;
		nextPutAll: theAttributeName;
		nextPutAll: ' = ';
		nextPutAll: (theValue printStringLimitedTo: 40);
		yourself.	
]).

(context tempAt: 7) = false ifTrue: [ html text: out ] ifFalse: [ html strong: out ].
html break
 

! !

WAConfigurationAttribute subclass: #WAMagmaLocationAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaLocationAttribute methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 10:00'!
accept: aVisitor with: anObject

	^ aVisitor visitMagmaLocationAttribute: self with: anObject! !

!WAMagmaLocationAttribute methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 11:55'!
options

	^ MagmaLocation allSubclasses! !

!MagmaLocation methodsFor: '*magma seaside' stamp: 'kph 9/9/2006 03:21'!
newSessionAs: userName

 ^ self newSession connectAs: userName; yourself! !

MaReadStrategy subclass: #WAMagmaReadStrategyDefault
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaReadStrategyDefault commentStamp: 'kph 6/12/2007 07:07' prior: 0!
This class is a subclass of MaReadStrategy enabling specialisation of read strategy behaviour.

WAMagmaSession asks us to build a readStrategy, our default is none (subclasses can override #buildThisStrategyOn:), we then ask 
the session to #buildReadStrategyOn: and the sessions default behavour is to ask the root object to #buildReadStrategyOn: 

This allows each application have its own strategy defined by its root object without needing any specialized sessions or strategies.

If you have a specialized readstrategy, or a specialised session you can override this behaviour.

Alternative admin-user selectable (via seaside/config) read strategies may be supplied by providing subclasses to this class. These may override the default building behaviour if desired. They may also over-ride MaReadStrategy behaivour.

In seaside the Session readStrategy is updated/rebuilt whenever there is a new seaside session, even when the MagmaSession and the repository is shared among server seaside sessions.

There is an enhancement to read strategies, whereby the user can specify a depth on one particular instVar of a class.!

!WAMagmaReadStrategyDefault class methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2007 07:07'!
buildThisStrategyOn: strategy

"subclasses may specialise this method"! !

!WAMagmaReadStrategyDefault class methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 05:56'!
isLogger

^false! !

!WAMagmaReadStrategyDefault class methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2007 09:57'!
setStrategyUsing: builder

| theStrategy |

theStrategy := self new.

self buildThisStrategyOn: theStrategy.
builder buildReadStrategyOn: theStrategy. 
 
^theStrategy! !

!WAMagmaReadStrategyDefault methodsFor: 'as yet unclassified' stamp: 'kph 10/4/2006 15:16'!
depthArrayOfSize: arraySize default: value

	^(Array new: arraySize) atAllPut: value; yourself! !

!WAMagmaReadStrategyDefault methodsFor: 'nil' stamp: 'kph 9/19/2006 17:56'!
forVariableNamed: aString onAny: aClass readToDepth: anInteger

| specs |

	(aClass allInstVarNames includes: aString)
		ifFalse:
			[ MagmaUserError signal: aString , ' is not an attribute of ' , aClass name ].
	
specs := depthSpecifications at: aClass ifAbsent: [ self onAny: aClass readToDepth: 0 ].

specs value ifNil: [ specs value: (self depthDictionaryOfSize: aClass instSize) ].
			
specs value at: aString
			put: anInteger! !

!WAMagmaReadStrategyDefault methodsFor: 'as yet unclassified' stamp: 'kph 9/19/2006 17:56'!
instVarMapFor: aMaClassDefinition
	"Answer an Array with an instVarMap of aMaClassDefinition according to user-declared read depths."

	| specifiedDepths answer |
	(aMaClassDefinition isDefined
	and: [ depthSpecifications includesKey: aMaClassDefinition classObject ])
		ifTrue:
			[ specifiedDepths _ depthSpecifications at: aMaClassDefinition classObject.
			specifiedDepths value
				ifNil: [ answer _ specifiedDepths key ]
				ifNotNil:
					[ answer _ self depthArrayOfSize: aMaClassDefinition namedInstSize default: specifiedDepths key.
					specifiedDepths value keysAndValuesDo:
						[ : eachInstVarName : eachDepth |
						answer
							at: (aMaClassDefinition allInstVarNames indexOf: eachInstVarName)
							put: eachDepth ] ] ].
	^ answer! !

!WAMagmaReadStrategyDefault methodsFor: 'nil' stamp: 'kph 9/20/2006 15:24'!
isLogged

^self class isLogger! !

!WAMagmaReadStrategyDefault methodsFor: 'as yet unclassified' stamp: 'kph 9/19/2006 17:56'!
onAny: aClass readToDepth: anInteger

	^depthSpecifications at: aClass ifAbsentPut: [ Association key: anInteger value: nil ].
! !

!WAMagmaReadStrategyDefault methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 13:43'!
renderOn: html

html text: ' minimumDepth: '; text: self minimumDepth; break.

depthSpecifications keysAndValuesDo: [ :k :v |  html strong: k; text: ' : '; text: v; break ].! !

WAMagmaReadStrategyDefault subclass: #WAMagmaReadStrategyWithLogging
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaReadStrategyWithLogging commentStamp: 'kph 5/24/2007 14:37' prior: 0!
Obsolete!

!WAMagmaReadStrategyWithLogging class methodsFor: 'nil' stamp: 'kph 9/20/2006 05:56'!
isLogger

^true! !

!WAMagmaReadStrategyWithLogging methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 14:41'!
logClass

^WAMagmaLog ! !

!WAMagmaReadStrategyWithLogging methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2006 14:46'!
log

^self logClass log! !

!WAMagmaReadStrategyWithLogging methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2006 05:28'!
signalBeginningToRead: oidInteger

	|timeStamp |					

	timeStamp := Time millisecondClockValue.
	self log entry: #readBegin context: thisContext! !

!WAMagmaReadStrategyWithLogging methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2006 05:24'!
testRead: oid 
    wantedAt: currentDepth
		   to: minDepth
 forAttribute: varIndex
ofClassWithId: classId
	  version: classVersion

"we log (lazily) by sending this method's context to the log, changing this method's args and 
 temporary variables may effect the Log's output"

| newMinDepth timeStamp |					
		
timeStamp := Time millisecondClockValue.
newMinDepth :=  super testRead: oid wantedAt: currentDepth
						to: minDepth
						forAttribute: varIndex
						ofClassWithId: classId
						version: classVersion.

self log entry: #testRead context: thisContext. 	

^newMinDepth! !

!UnixFileDirectory methodsFor: '*magma seaside' stamp: 'kph 9/1/2006 01:38'!
directoryExists: filenameOrPath
    "Handles the special case of testing for the root dir: there isn't a
    possibility to express the root dir as full pathname like '/foo'."

    ^ filenameOrPath = '/'
        or: [ filenameOrPath = self class default pathName
        or: [ super directoryExists: filenameOrPath ] ]
! !

WASession subclass: #WAMagmaSession
	instanceVariableNames: 'magmaSession holder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaSession commentStamp: 'kph 9/29/2006 02:15' prior: 0!
Experimental: the holder instVar is available to put a repository object(s) into for the duration of the session, in order to prevent realised objects from being garbage collected. When the session is unregistered the holder is set to nil releasing the object.!

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2007 06:58'!
buildReadStrategyOn: theReadStrategy

	| theRoot |

	((theRoot := self root) respondsTo: #buildReadStrategyOn:) 
		ifTrue: [ theRoot buildReadStrategyOn: theReadStrategy ].

	^theReadStrategy.
! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/9/2006 17:41'!
commit: aBlock

	self magmaSession commit: aBlock
! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/29/2006 02:15'!
holder

^holder! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/29/2006 02:15'!
holder: anObject

holder := anObject! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/9/2006 03:15'!
location 

^self application preferenceAt: #location.
! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2006 06:11'!
log: message

	|timeStamp |					
		
	timeStamp := Time millisecondClockValue. 

^self readStrategyClass isLogger ifTrue: [ WAMagmaLog log entry: 'seaside' context: thisContext ]
 ! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 14:29'!
magmaMaterializing: object! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/17/2006 17:16'!
magmaSession

^ magmaSession ifNil: [ 	magmaSession := self obtainMagmaSession ]! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2007 09:58'!
obtainMagmaSession

	| ms |

	self log: 'Obtaining MagmaSession'.

	ms := self location newSessionAs: 'seaside'.

	ms preferences signalProxyMaterializations: (self signalProxyMaterializations).
	ms readStrategy: (self readStrategyClass setStrategyUsing: self).		

	^ ms! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/17/2006 16:56'!
readStrategyClass

 ^ self application preferenceAt: #readStrategy! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2006 03:41'!
repositoryPath
	"This is a convenience method to get the repository directory path from Seaside"

	^ self application preferenceAt: #repositoryPath! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:52'!
root

	^ self magmaSession root
! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 10/6/2006 04:19'!
setMagmaSession: ms

magmaSession := ms! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 14:06'!
setPreferencesFor: aMagmaSession

	aMagmaSession preferences signalProxyMaterializations: (self signalProxyMaterializations)! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 14:06'!
signalProxyMaterializations

 ^ self application preferenceAt: #signalProxyMaterializations! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 10/6/2006 05:00'!
stubOut: anObject

	self magmaSession stubOut: anObject
! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2006 21:23'!
unregistered

holder := nil.
magmaSession ifNotNil: [ magmaSession disconnect. magmaSession := nil ]! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'kph 5/24/2007 14:28'!
withErrorHandler: aBlock
	^ [ super withErrorHandler: aBlock ] 
		on MagmaProxyMaterialization 
		do: [ :n | self magmaMaterializing: n materializedObject. n resume ].! !

WAMagmaSession subclass: #WAMagmaSharedSession
	instanceVariableNames: ''
	classVariableNames: 'MagmaSessions'
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaSharedSession commentStamp: 'kph 9/17/2006 02:42' prior: 0!
WAMagmaSharedSession keeps one session per repository, and this is provided to each Seaside Session. i.e. each seaside session can access the database but needs to be aware that it may be sharing its view of the model with other seaside sessions.

Pier has a model locking mechanism in place to prevent concurrent edits, and so will perform better with WAMagmaSharedSession than with a standard WAMagmaSession Since sharing the magma session avoids the overhead of connecting to the database at the beginning of every user session.

Rules for use:
Do not abort, you may ruin someone else's transaction.
Ensure that commits are negotiated amongst the sharing users via locking. If one seaside session commits: while another is in mid transaction their changes will be lost. 
To use a shared session there should be one data model that manages commits: and aborts on behalf of all of its seaside session clients.
!

WAMagmaSharedSession subclass: #CTMagmaSharedSession
	instanceVariableNames: 'handlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!CTMagmaSharedSession methodsFor: 'processing' stamp: 'lr 8/30/2006 12:04'!
cometRequest: aRequest
	^ (handlers
		at: (aRequest fields
			at: CTComet headerField
			ifAbsent: [ ^ nil ])
		ifAbsent: [ ^ nil ])
			connect: aRequest! !

!CTMagmaSharedSession methodsFor: 'processing' stamp: 'lr 7/12/2006 12:10'!
incomingRequest: aRequest
	aRequest responseStream
		ifNil: [ self error: 'Streaming-server required.' ].
	^ (aRequest fields includesKey: CTComet headerField)
		ifTrue: [ self cometRequest: aRequest ]
		ifFalse: [ super incomingRequest: aRequest ]! !

!CTMagmaSharedSession methodsFor: 'initialization' stamp: 'lr 7/12/2006 11:02'!
initializeWithApplication: anApplication
	super initializeWithApplication: anApplication.
	handlers := Dictionary new! !

!CTMagmaSharedSession methodsFor: 'public' stamp: 'lr 8/30/2006 11:57'!
registerPusher: aPusher context: aContext
	| handler |
	handler := CTHandler on: aPusher session: self context: aContext.
	handlers at: handler id put: handler.
	^ handler id! !

!WAMagmaSharedSession class methodsFor: 'class initialization' stamp: 'kph 9/9/2006 03:32'!
initialize

MagmaSessions := Dictionary new.! !

!WAMagmaSharedSession class methodsFor: 'class initialization' stamp: 'kph 9/19/2006 13:20'!
magmaSessions

^MagmaSessions

"self magmaSessions"! !

!WAMagmaSharedSession methodsFor: 'as yet unclassified' stamp: 'kph 9/17/2006 17:14'!
magmaAbortOnRequest.

"dont for a shared session"! !

!WAMagmaSharedSession methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2006 16:39'!
obtainMagmaSession

| ms |

ms := MagmaSessions at: (self location) ifAbsent: [ nil ].

((ms isNil or: [ ms isOpen not ]) or: [ ms isConnected not]) 
	ifTrue: [ ms := MagmaSessions at: self location put: super obtainMagmaSession ].

^ms! !

!WAMagmaSharedSession methodsFor: 'as yet unclassified' stamp: 'kph 9/24/2006 04:18'!
unregistered

	magmaSession ifNotNil: [ magmaSession := nil ]! !

!MaBasicReadStrategy methodsFor: '*magma seaside' stamp: 'kph 9/20/2006 23:39'!
signalBeginningToRead: oidInteger! !

!MaBasicReadStrategy methodsFor: '*magma seaside' stamp: 'kph 9/20/2006 13:41'!
testRead: oid wantedAt: currentDepth
			to: minDepth
			forAttribute: varIndex
			ofClassWithId: classId
			version: classVersion

| newMinDepth |

	currentDepth < (
						newMinDepth _
							(self 
								depthOfAttribute: varIndex
								onClassWithId: classId
								version: classVersion) + currentDepth
									max: minDepth)

	ifFalse: [ newMinDepth := false ].

^newMinDepth
! !

WADispatcherEditorPlugin subclass: #WAMagmaControlPanel
	instanceVariableNames: 'repositoryControlPanel textInput doneIt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaControlPanel commentStamp: 'kph 4/19/2007 23:28' prior: 0!
Architecture:

This control panel is made available as a plug-in to the seaside/config disptacher editor. The link 'magma' appears next to applications that have the group #magma. Since the seaside/config application session is not, nor should it be a WAMagmaSession, this control panel has to manage its own magmaSession. It does this by creating a psuedo seaside application, local to this control panel which has a magmaSession. It also registers for finalization in order to safely dispose of the psuedo application and to disconnect the magmaSession.

This control panel anticipates that each application using magma may have its own repository control/status panel class. The root object of the repository is sent #magmaControlPanelOn: <magmaSession> to obtain a control/status panel component, or a descriptive string. This is displayed as a sub-part of the WAMagmaControlPanel.

If there is no repository in place then the user is offered the option to create one. It searches for the repository control panels.  These are seaside-components which implement #magmaRootClass and #magmaRootDescription, sufficient information for the user to select a root object that is appropriate for their application.

[to do]
seasidehosting currently requires the user to manually create the repository directory in the filesystem.



!

!WAMagmaControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 4/19/2007 23:23'!
editorActionsFor: anEntryPoint inEditor: anEditor

| actions |

actions := super editorActionsFor: anEntryPoint inEditor: anEditor.
 
actions isEmpty ifTrue: [ ^ actions ].

(anEntryPoint preferenceAt: #readStrategy) isLogger  ifTrue: [ 		
		actions add: ((Dictionary new)
				at: #label put: 'view-log';
				at: #action put: [ anEditor call: (WAMagmaLog log forApplication: anEntryPoint)  ];
				yourself);
				yourself.
		actions add: ((Dictionary new)
				at: #label put: 'clear-log';
				at: #action put: [ anEditor call: (WAMagmaLog log forApplication: anEntryPoint) clear  ];
				yourself);
				yourself.

].
	
^ actions


! !

!WAMagmaControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 10/7/2006 12:18'!
initialize
"self initialize"
^super initialize! !

!WAMagmaControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 9/30/2006 02:32'!
label

^ #magma! !

!WAMagmaControlPanel methodsFor: 'all stats' stamp: 'kph 9/18/2006 04:18'!
cachedObjectsByClassForSession: aSession

^String streamContents: [ :stream |
	stream nextPutAll: 'cachedObjectCountByClass: '.
	aSession cachedObjectCountByClass 
		do: [ :assoc |
			stream nextPutAll: assoc printString.
			stream nextPutAll: ' '; cr.
		]
]! !

!WAMagmaControlPanel methodsFor: 'all stats' stamp: 'kph 4/19/2007 23:21'!
children

^ (repositoryControlPanel isKindOf: WAComponent) ifTrue: [ Array with: repositoryControlPanel ] ifFalse: [ #() ]! !

!WAMagmaControlPanel methodsFor: 'callback actions' stamp: 'kph 10/6/2006 12:00'!
createRepository: repositoryClass
	self psuedoAppSession unregistered.
	psuedoAppSession := nil.
	repositoryControlPanel := nil.
 MagmaRepositoryController create: self location root: repositoryClass new.
! !

!WAMagmaControlPanel methodsFor: 'callback actions' stamp: 'kph 10/6/2006 11:41'!
deleteRepository

| message1 message2 |

message1 := 'Are you sure that you want to delete repository: ', self location path.
message2 := 'Go ahead and delete repository: ',  self location path.

((self confirm: message1) and: [ self confirm: message2 ]) 
	ifTrue: [ 
		self psuedoAppSession expire.
		psuedoAppSession := nil.
		repositoryControlPanel := nil.
		(MagmaRepositoryController controllerOpenedOn: self location) ifNotNilDo: [ :mc |  mc close ].
		MagmaRepositoryController delete: self location.	
		
	].! !

!WAMagmaControlPanel methodsFor: 'callback actions' stamp: 'kph 9/4/2006 03:15'!
doIt: aString

doneIt := ( Compiler new evaluate: aString in: nil to: nil ) printString.
! !

!WAMagmaControlPanel methodsFor: 'callback actions' stamp: 'kph 9/18/2006 02:58'!
done

self psuedoAppSession expire.

self answer! !

!WAMagmaControlPanel methodsFor: 'finalization' stamp: 'kph 9/26/2006 22:11'!
executor

^ self class basicNew setExecutorsPsuedoAppSession: psuedoAppSession; yourself! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/23/2006 07:02'!
explore: sessionId inController: mrc

	self explore:(self findMagmaSessionWithId: sessionId inController: mrc)! !

!WAMagmaControlPanel methodsFor: 'callback actions' stamp: 'kph 9/18/2006 04:24'!
explore: aMagmaSession
 
 [ { aMagmaSession. aMagmaSession root } explore ] fork! !

!WAMagmaControlPanel methodsFor: 'finalization' stamp: 'kph 9/26/2006 22:15'!
finalize

psuedoAppSession ifNotNil: [

	psuedoAppSession unregistered.

]
! !

!WAMagmaControlPanel methodsFor: 'all stats' stamp: 'kph 9/20/2006 15:05'!
findMagmaSessionWithId: id inController: mrc

^MagmaSession allInstances detect: [ :ms | (ms id = id) and: [ ms link localRequestServer processor = mrc ] ] ifNone: [ nil ]! !

!WAMagmaControlPanel methodsFor: 'testing' stamp: 'kph 9/5/2006 23:43'!
hasScriptaculous
	Smalltalk at: #SULibrary ifPresent: [ :class |
		^ self session application libraries
			includes: class ].
	^ false! !

!WAMagmaControlPanel methodsFor: 'initialization' stamp: 'kph 9/26/2006 22:05'!
initialize

super initialize.

self registerForFinalization.! !

!WAMagmaControlPanel methodsFor: 'accessing' stamp: 'kph 9/18/2006 01:27'!
location

^ self application preferenceAt: #location! !

!WAMagmaControlPanel methodsFor: 'accessing' stamp: 'kph 9/18/2006 02:59'!
magmaSession

^self psuedoAppSession magmaSession
! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/18/2006 03:29'!
magmaSession: aBlock ifAbsent: notThereBlock

aBlock
	on: MagmaEnvironmentError 
	do: notThereBlock.  ! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 5/24/2007 13:41'!
presentCreateRepositoryOptionsOn: html

	html heading level: 3; with: [ html text:  'options:'].
		html text: 'You may create a repository with one of the following root objects for this application.'.
		html div class: 'repositories'; with: [ 
			html table: [
				((SystemNavigation default allImplementorsOf: #magmaRootClass) collect: [ :m | m actualClass soleInstance ])				
				do: [ :c | 
						html tableRow: [ 
					 			html tableData: [ html strong:  c magmaRootClass name ].
								html tableData: [ html text:   c magmaRootDescription ].
								html tableData: [ html submitButton callback: [ self createRepository: c magmaRootClass ]; text: 'Create'. ]
						] 
					]
				]
			].! !

!WAMagmaControlPanel methodsFor: 'accessing' stamp: 'kph 4/19/2007 05:12'!
psuedoAppSession

^psuedoAppSession ifNil: [ 
	psuedoAppSession := (application preferenceAt: #sessionClass) new setParent: self application ]! !

!WAMagmaControlPanel methodsFor: 'finalization' stamp: 'kph 9/26/2006 22:06'!
registerForFinalization

self finalizationRegistry add: self executor: self executor.! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 5/24/2007 13:42'!
renderApplicationStatusOn: html

	| readStrategy |

	self magmaSession.
 	self renderLocationOn: html.
	self location isLocal ifTrue: [  html text: '   '. 
		html small: [ 
			html anchor 
				callback: [ self deleteRepository ]; 
				title: 'delete the repository from disk';
				text: '(delete)'. 
		]
	].

	html break.

	html strong: 'Persisted Objects Count: '.
	html text: self magmaSession repositoryController objectCount.

	html break.

	html strong: 'Seaside Session: '.
	html text: self psuedoAppSession printString.

	html break.

	html strong: 'Session: '.
	html text: self magmaSession printString.

	html break.

	html strong: 'Session Id: '.
	html text: self magmaSession id.

	html break.

	html strong: 'Cached Object Count: '.
	html text: self magmaSession cachedObjectCount.

	html break.

	readStrategy := self magmaSession readStrategy.

	html strong: 'ReadStrategy: '.
	html text: (readStrategy ifNil: [ 'No Read Strategy Set' ]) asString.

	
	((readStrategy respondsTo:  #isLogged) and: [ readStrategy isLogged ]) ifTrue: [
			html anchor callback: [ self call: (WAMagmaLog log forApplication: application)  ]; text: '(log)'.
		].

	html break.

	html strong: 'Root Object: '.
	html text: self magmaSession root asString.
	
	html text: ' '.
	html small: [ 
		html anchor callback: [ self explore: self magmaSession ]; 
			title: 'open explorer in squeak';
			text: '(explore)'.
			.
	].
! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/22/2006 00:54'!
renderContentOn: html

	html heading: 'Application: ', application name.

html form: [

	self magmaSession: [ self renderApplicationStatusOn: html.
			html horizontalRule.
			html render: self repositoryControlPanel.
			html horizontalRule. 
		] 
		ifAbsent: [ :ex | self renderMagmaError: ex on: html ].

	html break.
	html submitButton on: #done of: self.

	html horizontalRule.

	html heading: 'Overall Magma Status'.
	 
	self renderMagmaPreferencesOn: html.
	self renderStatsForAllRepositoriesOn: html.
	
	self renderUtilsOn: html.

].! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/4/2006 02:01'!
renderEvaluatorOn: html
	self
		renderLabel: 'Text-Input'
		control: [ :fid :mid |
			html textInput
				value: textInput;
				callback: [ :value | textInput := value ].
			html space.
			html submitButton
				onClick: (html updater
					id: mid;
					triggerForm: fid;
					callback: [ :r | r render: textInput ];
					return: false);
				text: 'Submit' ]
		model: textInput
		on: html! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 8/10/2006 16:38'!
rendererClass
        ^ WARenderCanvas ! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/4/2006 02:13'!
renderLabel: aString control: aBlock model: anObject on: html
	| fid mid |
	fid := mid := nil.
	html div class: 'row'; with: [
		html div class: 'label'; with: aString.
		html div class: 'control'; with: [
			html form
				id: (fid := html nextId);
				with: [ aBlock value: fid value: (mid := html nextId) ] ].
		html div class: 'model'; id: mid; with: anObject.
		html div class: 'clear' ]! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 5/24/2007 13:42'!
renderLocationOn: html

	self location isLocal 
		ifTrue: [
			html strong: 'Repository Path Setting: '.
			html text: self location path.
 		]
		ifFalse: [ 
			html strong: 'Repository remote host: '.
			html text: self location host , ':' , self location port
		].
		
! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 5/24/2007 13:42'!
renderMagmaError: ex on: html

	self renderLocationOn: html.
	html break.
	html strong: 'Error: ', ex messageText.
	html break.
	self location isLocal 
		ifTrue: [ self renderPresentCreateRepositoryOptionsOn: html	] 
		ifFalse: [ html text: 'Remote repository not available' ].! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 5/24/2007 13:42'!
renderMagmaPreferencesOn: html

html strong: 'debug proxies '.
html checkbox title: 'print shows proxy'; on: #debugProxies of: MagmaPreferences.
html strong: 'hand status '.
html checkbox title: 'show wait cursor when submitting magma requests'; on: #handStatus of: MagmaPreferences.
html strong: 'debug '.
html checkbox title: 'onError Halt, and 2 day server link timeout'; on: #debug of: MagmaPreferences.! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 5/24/2007 13:42'!
renderPresentCreateRepositoryOptionsOn: html

	html heading level: 3; with: [ html text:  'options:'].
		html text: 'You may create a repository with one of the following root objects for this application.'.
		html div class: 'repositories'; with: [ 
			html table: [
				((SystemNavigation default allImplementorsOf: #magmaRootClass) collect: [ :m | m actualClass soleInstance ])				
				do: [ :c | 
						html tableRow: [ 
					 			html tableData: [ html strong:  c magmaRootClass name ].
								html tableData: [ html strong:   c magmaRootDescription ].
								html tableData: [ html submitButton callback: [ self createRepository: c magmaRootClass ]; text: 'Create'. ]
						] 
					]
				]
			].! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/4/2006 03:16'!
renderServerDoItOn: html
	self
		renderLabel: 'Server Do It'
		control: [ :fid :mid |
			html textInput
				value: textInput;
				callback: [ :value | self doIt: (textInput := value).  ].
			html space.
			html submitButton
				onClick: (html updater
					id: mid;
					triggerForm: fid;
					callback: [ :r | r render:textInput ];
					return: false);
				text: 'do it' ]
		model: doneIt 
		on: html! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 5/24/2007 13:45'!
renderStatsForAllRepositoriesOn: html

| mSession |

html orderedList: [ 
	MagmaRepositoryController openControllers do: [ :mrc |
		
		html listItem: [
			html strong: mrc objectCount.
			html text: ' objects in repository: '.
			 
			 html strong: mrc pathName.
			html orderedList: [
				mrc repository sessions do: [ :client |
					
					mSession := self findMagmaSessionWithId: client sessionId inController: mrc.

					html listItem: [
						mSession ifNil: [ html text: 'session not found' ]
							ifNotNil: [ 
								html strong: 'session id: '.
								html text: client sessionId printString.
								html strong: ' cached objects: '.
								html anchor callback: [ self showCachedObjectsByClassFor: client sessionId inController: mrc ]; 
								text: mSession cachedObjectCount.
							html text: ' '.
							html small: [ html anchor callback: [ self explore: client sessionId inController: mrc ]; text: '(explore)' ].
						]
					].
				]	 
			].			
				"html tableData: [ html text: c numberOfConnectedClients asString ]."
		].
	].
]
	 
 
 


 ! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 5/24/2007 13:43'!
renderUtilsOn: html

html horizontalRule.

html strong: 'Miscellaneous Utilities: '.

html break.

html submitButton callback: [ MagmaSession cleanUp.
							  repositoryControlPanel := nil ]; text: 'MagmaSession cleanUp'.

html break.

html submitButton callback: [ WAMagmaSharedSession initialize. ]; title: 'New Sessions (Reloads ReadStrategies)';  text: 'Reset WAMagmaSharedSession'.

html break.


html submitButton callback: [ self saveImageSnapshot. self magmaSession begin ]; text: 'Save Server Image'.

self hasScriptaculous ifTrue: [ html horizontalRule.  self renderServerDoItOn: html ].! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/18/2006 04:41'!
repositoryControlPanel

| root |

repositoryControlPanel ifNil: [
	root := self magmaSession root.
	(root respondsTo: #magmaControlPanelOn: ) 
		ifTrue: [ repositoryControlPanel := root magmaControlPanelOn: self magmaSession ]
].

^repositoryControlPanel! !

!WAMagmaControlPanel methodsFor: 'callback actions' stamp: 'kph 9/4/2006 01:43'!
saveImageSnapshot

 SmalltalkImage current snapshot: true andQuit: false.! !

!WAMagmaControlPanel methodsFor: 'finalization' stamp: 'kph 9/26/2006 22:05'!
setExecutorsPsuedoAppSession: psa

psuedoAppSession := psa! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 9/23/2006 07:00'!
showCachedObjectsByClassFor:  sessionId inController: mrc 

self inform: (self cachedObjectsByClassForSession: (self findMagmaSessionWithId: sessionId inController: mrc))! !

!WAMagmaControlPanel methodsFor: 'rendering' stamp: 'kph 8/11/2006 14:16'!
style

^ 

'
div.repositories table td {
	border: 1px solid #888;

'! !
WAMagmaSharedSession initialize!
WAMagmaControlPanel initialize!
